/*
 * main.c
 *
 * Created: 9/21/2023 10:32:44 AM
*  Author: controllerstech
*/

#define F_CPU 5000000
#include <xc.h>
#include <util/delay.h>
#include <avr/interrupt.h>

void clkInit(void)
{
	_PROTECTED_WRITE(CLKCTRL.MCLKCTRLA, 0);  // Internal 20MHz OSC, CLKOUT=0
	_PROTECTED_WRITE(CLKCTRL.MCLKCTRLB, 0x03);  // PEN=1, DIV=4
	while ((CLKCTRL.MCLKSTATUS & (1<<4)) == 0);  // wait for the osc to stabilize.
}

int main(void)
{
	clkInit();
	PORTC.DIR = 0x01;  // PC5->input, PC0->output
	PORTC.PIN5CTRL |= 0x2;  // falling sense
	sei();
    while(1)
    {
/*		if ((PORTC.IN & (1<<5)) == 0)
		{
			PORTC.OUT |= (1<<0);  // turn the LED ON
			while ((PORTC.IN & (1<<5)) == 0);  // wait for the button to release
		}
*/		
//		PORTC.OUT &= ~(1<<0);
//		_delay_ms(500);
        //TODO:: Please write your application code 
    }
}

ISR(PORTC_PORT_vect)
{
	uint8_t flag = PORTC.INTFLAGS;
	if (((flag>>5)&0x01) == 1)  // if the interrupt is triggered by the pin PC5
	{
		PORTC.OUTTGL = (1<<0);  // turn the LED ON
		PORTC.INTFLAGS |= (1<<5);  // clear the interrupt flag
	}
	
}